interface mem_intf(input clk);

  wire  [7:0] data;
  logic [4:0] addr;
  logic read;
  logic write;

  modport tb  ( input data,  
                output addr, read, write );
  modport mem ( output data, 
                input  addr, read, write );

logic [7:0] data_out;
assign data = write ? data_out : 'z;

task read_mem (input [4:0] raddr, output [7:0] rdata, input debug = 0);
   @(negedge clk)
         write <= 0;
         read  <= 1;
         addr  <= raddr;
   @(posedge clk)
     #1step
         rdata <= data;
         if (debug == 1) 
            $strobe("Read  - Address:%d  Data:%h", raddr, rdata);
    @(negedge clk) read <= 0;
endtask

task write_mem (input [4:0] waddr, input [7:0] wdata, input debug = 0);
  @(negedge clk)
    write <= 1;
    read  <= 0;
    addr  <= waddr;
    data_out  <= wdata;
    if (debug == 1)
        $strobe("Write - Address:%d  Data:%h", waddr, wdata);
  @(negedge clk) write <= 0;
endtask

endinterface : mem_intf
