module mem_test ( input     clk, 
                  interface mbus
                );
//Local Variables
bit         debug = 1;
logic [7:0] rdata;     // stores data read from memory for checking

// Monitor Results
  initial begin
      $timeformat ( -9, 1, " ns", 9 );
      #4000ns $display ( "MEMORY TEST TIMEOUT" );
      $finish;
    end

initial
  begin: memtest
    int error_status;
    $display("Clearing the memory");
    for (int i = 0; i< 32; i++)
       mbus.write_mem (i, 0, 0);
    for (int i = 0; i<32; i++)
      begin 
       mbus.read_mem (i, rdata, 0);
       if (rdata != 0)
          error_status++;
      end
    printstatus(error_status);

    $display("Data = Address Test");
    error_status = 0;
    for (int i = 0; i< 32; i++)
       mbus.write_mem (i, i, debug);
    for (int i = 0; i<32; i++)
      begin
       mbus.read_mem (i, rdata, debug);
       if (rdata != i)
         error_status++; 
      end
    printstatus(error_status);
 
    $finish;
  end

function void printstatus(input int status);
if (status == 0)
   $display("Test Passed - No Errors!");
else
   $display("Test Failed with %d Errors", status);
endfunction

endmodule
